
#include <iostream>
#include <locale>
#include <bits/stdc++.h>
#include <cmath>

using namespace std;


class point {
public:
    point(int ax, int ay): x(ax),y(ay){
        
    } 
   int x;
   int y;

};
struct PointCmp {
    bool operator()(const point& lhs, const point& rhs) const { 
        return (lhs.x < rhs.x || lhs.y < rhs.y);
    }
};
int euklid(int m, int n){
    int tmp = m;
    while(n > 0){
        
        tmp = m - n*(m/n); 
        m = n;
        n = tmp;
    }
    return m;
    
}

int main(int argc, char** argv) {

    std::ios::sync_with_stdio(false);
    int n;
    while(cin >> n){
        int x,y;
        vector <point> points;
        set <point,PointCmp> mnozina;
        int total = n*n,res=0;
        for(int j = 0; j < n; j++){
            
            cin >> x >> y;
            int gcd = euklid(x,y);
            if(gcd > 1){
                x = x/gcd;
                y = y/gcd;
            }
            cout << "gcd: " << gcd << endl;
            if(mnozina.find(point(x,y)) != mnozina.end() || mnozina.find(point(y,x)) != mnozina.end()){
                cout << "nasel jsem pro bod " << x*gcd << "," << y*gcd << endl;
                res += 2;
            }
            cout << "Vkladam bod " << x << "," << y << endl;
            mnozina.insert(point(x,y));
           
        }
        cout << "TEST: " << res << endl;
        
        cout << (double)res/(double)total << endl;
        mnozina.clear();
    }
    return 0;
}

